# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::CDN::Mgmt::V2020_04_15
  module Models
    #
    # Defines the common attributes for a custom rule that can be included in a
    # waf policy
    #
    class CustomRule

      include MsRestAzure

      # @return [String] Defines the name of the custom rule
      attr_accessor :name

      # @return [CustomRuleEnabledState] Describes if the custom rule is in
      # enabled or disabled state. Defaults to Enabled if not specified.
      # Possible values include: 'Disabled', 'Enabled'
      attr_accessor :enabled_state

      # @return [Integer] Defines in what order this rule be evaluated in the
      # overall list of custom rules
      attr_accessor :priority

      # @return [Array<MatchCondition>] List of match conditions.
      attr_accessor :match_conditions

      # @return [ActionType] Describes what action to be applied when rule
      # matches. Possible values include: 'Allow', 'Block', 'Log', 'Redirect'
      attr_accessor :action


      #
      # Mapper for CustomRule class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'CustomRule',
          type: {
            name: 'Composite',
            class_name: 'CustomRule',
            model_properties: {
              name: {
                client_side_validation: true,
                required: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              enabled_state: {
                client_side_validation: true,
                required: false,
                serialized_name: 'enabledState',
                type: {
                  name: 'String'
                }
              },
              priority: {
                client_side_validation: true,
                required: true,
                serialized_name: 'priority',
                constraints: {
                  InclusiveMaximum: 1000,
                  InclusiveMinimum: 0
                },
                type: {
                  name: 'Number'
                }
              },
              match_conditions: {
                client_side_validation: true,
                required: true,
                serialized_name: 'matchConditions',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'MatchConditionElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'MatchCondition'
                      }
                  }
                }
              },
              action: {
                client_side_validation: true,
                required: true,
                serialized_name: 'action',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
