# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::CDN::Mgmt::V2020_04_15
  module Models
    #
    # Defines the parameters for the Url Signing action.
    #
    class UrlSigningActionParameters

      include MsRestAzure

      # @return [Enum] Possible values include:
      # '#Microsoft.Azure.Cdn.Models.DeliveryRuleUrlSigningActionParameters'
      attr_accessor :odatatype

      # @return [String] Id reference of the key to be used to verify the hash
      # and should be defined in UrlSigningKeys
      attr_accessor :key_id

      # @return [Algorithm] Algorithm to use for URL signing. Possible values
      # include: 'SHA256'
      attr_accessor :algorithm

      # @return [Array<UrlSigningParamIdentifier>] Defines which query string
      # parameters in the url to be considered for expires, key id etc.
      attr_accessor :parameter_name_override

      # @return [Array<String>] Match values to match against. Supports CIDR
      # ranges (both IPv4 and IPv6).
      attr_accessor :ip_subnets


      #
      # Mapper for UrlSigningActionParameters class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'UrlSigningActionParameters',
          type: {
            name: 'Composite',
            class_name: 'UrlSigningActionParameters',
            model_properties: {
              odatatype: {
                client_side_validation: true,
                required: false,
                serialized_name: '@odata\\.type',
                type: {
                  name: 'String'
                }
              },
              key_id: {
                client_side_validation: true,
                required: true,
                serialized_name: 'keyId',
                type: {
                  name: 'String'
                }
              },
              algorithm: {
                client_side_validation: true,
                required: false,
                serialized_name: 'algorithm',
                type: {
                  name: 'String'
                }
              },
              parameter_name_override: {
                client_side_validation: true,
                required: false,
                serialized_name: 'parameterNameOverride',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'UrlSigningParamIdentifierElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'UrlSigningParamIdentifier'
                      }
                  }
                }
              },
              ip_subnets: {
                client_side_validation: true,
                required: false,
                serialized_name: 'ipSubnets',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
