# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::CDN::Mgmt::V2020_09_01
  module Models
    #
    # Friendly domain name mapping to the endpoint hostname that the customer
    # provides for branding purposes, e.g. www.contoso.com.
    #
    class AFDDomain < ProxyResource

      include MsRestAzure

      # @return [AFDDomainHttpsParameters] The configuration specifying how to
      # enable HTTPS for the domain - using AzureFrontDoor managed certificate
      # or user's own certificate. If not specified, enabling ssl uses
      # AzureFrontDoor managed certificate by default.
      attr_accessor :tls_settings

      # @return [ResourceReference] Resource reference to the Azure DNS zone
      attr_accessor :azure_dns_zone

      # @return [AfdProvisioningState] Provisioning status. Possible values
      # include: 'Succeeded', 'Failed', 'Updating', 'Deleting', 'Creating'
      attr_accessor :provisioning_state

      # @return [DeploymentStatus] Possible values include: 'NotStarted',
      # 'InProgress', 'Succeeded', 'Failed'
      attr_accessor :deployment_status

      # @return [DomainValidationState] Provisioning substate shows the
      # progress of custom HTTPS enabling/disabling process step by step. DCV
      # stands for DomainControlValidation. Possible values include: 'Unknown',
      # 'Submitting', 'Pending', 'TimedOut', 'PendingRevalidation', 'Approved'
      attr_accessor :domain_validation_state

      # @return [String] The host name of the domain. Must be a domain name.
      attr_accessor :host_name

      # @return [DomainValidationProperties] Values the customer needs to
      # validate domain ownership
      attr_accessor :validation_properties


      #
      # Mapper for AFDDomain class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'AFDDomain',
          type: {
            name: 'Composite',
            class_name: 'AFDDomain',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              system_data: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'systemData',
                type: {
                  name: 'Composite',
                  class_name: 'SystemData'
                }
              },
              tls_settings: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.tlsSettings',
                type: {
                  name: 'Composite',
                  class_name: 'AFDDomainHttpsParameters'
                }
              },
              azure_dns_zone: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.azureDnsZone',
                type: {
                  name: 'Composite',
                  class_name: 'ResourceReference'
                }
              },
              provisioning_state: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.provisioningState',
                type: {
                  name: 'String'
                }
              },
              deployment_status: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.deploymentStatus',
                type: {
                  name: 'String'
                }
              },
              domain_validation_state: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.domainValidationState',
                type: {
                  name: 'String'
                }
              },
              host_name: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.hostName',
                type: {
                  name: 'String'
                }
              },
              validation_properties: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.validationProperties',
                type: {
                  name: 'Composite',
                  class_name: 'DomainValidationProperties'
                }
              }
            }
          }
        }
      end
    end
  end
end
