# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::CDN::Mgmt::V2020_09_01
  module Models
    #
    # The JSON object that contains the properties to secure a domain.
    #
    class AFDDomainHttpsParameters

      include MsRestAzure

      # @return [AfdCertificateType] Defines the source of the SSL certificate.
      # Possible values include: 'CustomerCertificate', 'ManagedCertificate'
      attr_accessor :certificate_type

      # @return [AfdMinimumTlsVersion] TLS protocol version that will be used
      # for Https. Possible values include: 'TLS10', 'TLS12'
      attr_accessor :minimum_tls_version

      # @return [ResourceReference] Resource reference to the secret. ie.
      # subs/rg/profile/secret
      attr_accessor :secret


      #
      # Mapper for AFDDomainHttpsParameters class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'AFDDomainHttpsParameters',
          type: {
            name: 'Composite',
            class_name: 'AFDDomainHttpsParameters',
            model_properties: {
              certificate_type: {
                client_side_validation: true,
                required: true,
                serialized_name: 'certificateType',
                type: {
                  name: 'String'
                }
              },
              minimum_tls_version: {
                client_side_validation: true,
                required: false,
                serialized_name: 'minimumTlsVersion',
                type: {
                  name: 'Enum',
                  module: 'AfdMinimumTlsVersion'
                }
              },
              secret: {
                client_side_validation: true,
                required: false,
                serialized_name: 'secret',
                type: {
                  name: 'Composite',
                  class_name: 'ResourceReference'
                }
              }
            }
          }
        }
      end
    end
  end
end
