# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::CDN::Mgmt::V2020_09_01
  module Models
    #
    # Customer Certificate used for https
    #
    class CustomerCertificate < Certificate

      include MsRestAzure

      # @return [String] Certificate version.
      attr_accessor :version

      # @return [String] Certificate issuing authority.
      attr_accessor :certificate_authority

      # @return [String] Complete Url to the certificate
      attr_accessor :certificate_url

      # @return [Boolean] Whether to use the latest version for the certificate
      attr_accessor :use_latest_version

      # @return [Array<String>] The list of SANs.
      attr_accessor :subject_alternative_names


      #
      # Mapper for CustomerCertificate class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'CustomerCertificate',
          type: {
            name: 'Composite',
            class_name: 'CustomerCertificate',
            model_properties: {
              subject: {
                client_side_validation: true,
                required: false,
                serialized_name: 'subject',
                type: {
                  name: 'String'
                }
              },
              expiration_date: {
                client_side_validation: true,
                required: false,
                serialized_name: 'expirationDate',
                type: {
                  name: 'String'
                }
              },
              thumbprint: {
                client_side_validation: true,
                required: false,
                serialized_name: 'thumbprint',
                type: {
                  name: 'String'
                }
              },
              version: {
                client_side_validation: true,
                required: false,
                serialized_name: 'version',
                type: {
                  name: 'String'
                }
              },
              certificate_authority: {
                client_side_validation: true,
                required: false,
                serialized_name: 'certificateAuthority',
                type: {
                  name: 'String'
                }
              },
              certificate_url: {
                client_side_validation: true,
                required: true,
                serialized_name: 'certificateUrl',
                type: {
                  name: 'String'
                }
              },
              use_latest_version: {
                client_side_validation: true,
                required: false,
                serialized_name: 'useLatestVersion',
                type: {
                  name: 'Boolean'
                }
              },
              subject_alternative_names: {
                client_side_validation: true,
                required: false,
                serialized_name: 'subjectAlternativeNames',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
