# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::CDN::Mgmt::V2020_09_01
  module Models
    #
    # The JSON object that contains the properties to send health probes to
    # origin.
    #
    class HealthProbeParameters

      include MsRestAzure

      # @return [String] The path relative to the origin that is used to
      # determine the health of the origin.
      attr_accessor :probe_path

      # @return [HealthProbeRequestType] The type of health probe request that
      # is made. Possible values include: 'NotSet', 'GET', 'HEAD'
      attr_accessor :probe_request_type

      # @return [ProbeProtocol] Protocol to use for health probe. Possible
      # values include: 'NotSet', 'Http', 'Https'
      attr_accessor :probe_protocol

      # @return [Integer] The number of seconds between health probes.Default
      # is 240sec.
      attr_accessor :probe_interval_in_seconds


      #
      # Mapper for HealthProbeParameters class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'HealthProbeParameters',
          type: {
            name: 'Composite',
            class_name: 'HealthProbeParameters',
            model_properties: {
              probe_path: {
                client_side_validation: true,
                required: false,
                serialized_name: 'probePath',
                type: {
                  name: 'String'
                }
              },
              probe_request_type: {
                client_side_validation: true,
                required: false,
                serialized_name: 'probeRequestType',
                type: {
                  name: 'Enum',
                  module: 'HealthProbeRequestType'
                }
              },
              probe_protocol: {
                client_side_validation: true,
                required: false,
                serialized_name: 'probeProtocol',
                type: {
                  name: 'Enum',
                  module: 'ProbeProtocol'
                }
              },
              probe_interval_in_seconds: {
                client_side_validation: true,
                required: false,
                serialized_name: 'probeIntervalInSeconds',
                constraints: {
                  InclusiveMaximum: 255,
                  InclusiveMinimum: 1
                },
                type: {
                  name: 'Number'
                }
              }
            }
          }
        }
      end
    end
  end
end
