# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::CDN::Mgmt::V2020_09_01
  module Models
    #
    # Defines the parameters for PostArgs match conditions
    #
    class PostArgsMatchConditionParameters

      include MsRestAzure

      # @return [String] . Default value:
      # '#Microsoft.Azure.Cdn.Models.DeliveryRulePostArgsConditionParameters' .
      attr_accessor :odatatype

      # @return [String] Name of PostArg to be matched
      attr_accessor :selector

      # @return [PostArgsOperator] Describes operator to be matched. Possible
      # values include: 'Any', 'Equal', 'Contains', 'BeginsWith', 'EndsWith',
      # 'LessThan', 'LessThanOrEqual', 'GreaterThan', 'GreaterThanOrEqual',
      # 'RegEx'
      attr_accessor :operator

      # @return [Boolean] Describes if this is negate condition or not
      attr_accessor :negate_condition

      # @return [Array<String>] The match value for the condition of the
      # delivery rule
      attr_accessor :match_values

      # @return [Array<Transform>] List of transforms
      attr_accessor :transforms


      #
      # Mapper for PostArgsMatchConditionParameters class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'PostArgsMatchConditionParameters',
          type: {
            name: 'Composite',
            class_name: 'PostArgsMatchConditionParameters',
            model_properties: {
              odatatype: {
                client_side_validation: true,
                required: true,
                is_constant: true,
                serialized_name: '@odata\\.type',
                default_value: '#Microsoft.Azure.Cdn.Models.DeliveryRulePostArgsConditionParameters',
                type: {
                  name: 'String'
                }
              },
              selector: {
                client_side_validation: true,
                required: false,
                serialized_name: 'selector',
                type: {
                  name: 'String'
                }
              },
              operator: {
                client_side_validation: true,
                required: true,
                serialized_name: 'operator',
                type: {
                  name: 'String'
                }
              },
              negate_condition: {
                client_side_validation: true,
                required: false,
                serialized_name: 'negateCondition',
                type: {
                  name: 'Boolean'
                }
              },
              match_values: {
                client_side_validation: true,
                required: false,
                serialized_name: 'matchValues',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              transforms: {
                client_side_validation: true,
                required: false,
                serialized_name: 'transforms',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'TransformElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
