# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::CDN::Mgmt::V2020_09_01
  module Models
    #
    # CDN profile is a logical grouping of endpoints that share the same
    # settings, such as CDN provider and pricing tier.
    #
    class Profile < TrackedResource

      include MsRestAzure

      # @return [Sku] The pricing tier (defines a CDN provider, feature list
      # and rate) of the CDN profile.
      attr_accessor :sku

      # @return [ProfileResourceState] Resource status of the profile. Possible
      # values include: 'Creating', 'Active', 'Deleting', 'Disabled'
      attr_accessor :resource_state

      # @return [String] Provisioning status of the profile.
      attr_accessor :provisioning_state

      # @return [String] The Id of the frontdoor.
      attr_accessor :frontdoor_id


      #
      # Mapper for Profile class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'Profile',
          type: {
            name: 'Composite',
            class_name: 'Profile',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              location: {
                client_side_validation: true,
                required: true,
                serialized_name: 'location',
                type: {
                  name: 'String'
                }
              },
              tags: {
                client_side_validation: true,
                required: false,
                serialized_name: 'tags',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              system_data: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'systemData',
                type: {
                  name: 'Composite',
                  class_name: 'SystemData'
                }
              },
              sku: {
                client_side_validation: true,
                required: true,
                serialized_name: 'sku',
                type: {
                  name: 'Composite',
                  class_name: 'Sku'
                }
              },
              resource_state: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.resourceState',
                type: {
                  name: 'String'
                }
              },
              provisioning_state: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.provisioningState',
                type: {
                  name: 'String'
                }
              },
              frontdoor_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.frontdoorId',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
