# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::CDN::Mgmt::V2020_09_01
  module Models
    #
    # Describes the properties of an existing Shared Private Link Resource to
    # use when connecting to a private origin.
    #
    class SharedPrivateLinkResourceProperties

      include MsRestAzure

      # @return [ResourceReference] The resource id of the resource the shared
      # private link resource is for.
      attr_accessor :private_link

      # @return [String] The location of the shared private link resource
      attr_accessor :private_link_location

      # @return [String] The group id from the provider of resource the shared
      # private link resource is for.
      attr_accessor :group_id

      # @return [String] The request message for requesting approval of the
      # shared private link resource.
      attr_accessor :request_message

      # @return [SharedPrivateLinkResourceStatus] Status of the shared private
      # link resource. Can be Pending, Approved, Rejected, Disconnected, or
      # Timeout. Possible values include: 'Pending', 'Approved', 'Rejected',
      # 'Disconnected', 'Timeout'
      attr_accessor :status


      #
      # Mapper for SharedPrivateLinkResourceProperties class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'SharedPrivateLinkResourceProperties',
          type: {
            name: 'Composite',
            class_name: 'SharedPrivateLinkResourceProperties',
            model_properties: {
              private_link: {
                client_side_validation: true,
                required: false,
                serialized_name: 'privateLink',
                type: {
                  name: 'Composite',
                  class_name: 'ResourceReference'
                }
              },
              private_link_location: {
                client_side_validation: true,
                required: false,
                serialized_name: 'privateLinkLocation',
                type: {
                  name: 'String'
                }
              },
              group_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'groupId',
                type: {
                  name: 'String'
                }
              },
              request_message: {
                client_side_validation: true,
                required: false,
                serialized_name: 'requestMessage',
                type: {
                  name: 'String'
                }
              },
              status: {
                client_side_validation: true,
                required: false,
                serialized_name: 'status',
                type: {
                  name: 'Enum',
                  module: 'SharedPrivateLinkResourceStatus'
                }
              }
            }
          }
        }
      end
    end
  end
end
